<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSignedDocument ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSignedDocument
 * @subpackage Arrays
 */
class ArrayOfSignedDocument extends AbstractStructArrayBase
{
    /**
     * The SignedDocument
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var SignedDocument[]
     */
    public $SignedDocument;
    /**
     * Constructor method for ArrayOfSignedDocument
     * @uses ArrayOfSignedDocument::setSignedDocument()
     * @param SignedDocument[] $signedDocument
     */
    public function __construct(array $signedDocument = array())
    {
        $this
            ->setSignedDocument($signedDocument);
    }
    /**
     * Get SignedDocument value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return SignedDocument[]|null
     */
    public function getSignedDocument()
    {
        return isset($this->SignedDocument) ? $this->SignedDocument : null;
    }
    /**
     * Set SignedDocument value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param SignedDocument[] $signedDocument
     * @return ArrayOfSignedDocument
     */
    public function setSignedDocument(array $signedDocument = array())
    {
        if (is_null($signedDocument) || (is_array($signedDocument) && empty($signedDocument))) {
            unset($this->SignedDocument);
        } else {
            $this->SignedDocument = $signedDocument;
        }
        return $this;
    }
    /**
     * Add item to SignedDocument value
     * @throws \InvalidArgumentException
     * @param SignedDocument $item
     * @return ArrayOfSignedDocument
     */
    public function addToSignedDocument(SignedDocument $item)
    {
        $this->SignedDocument[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return SignedDocument|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return SignedDocument|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return SignedDocument|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return SignedDocument|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return SignedDocument|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SignedDocument
     */
    public function getAttributeName()
    {
        return 'SignedDocument';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return ArrayOfSignedDocument
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
