<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUploadDocument ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUploadDocument
 * @subpackage Arrays
 */
class ArrayOfUploadDocument extends AbstractStructArrayBase
{
    /**
     * The UploadDocument
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var UploadDocument[]
     */
    public $UploadDocument;
    /**
     * Constructor method for ArrayOfUploadDocument
     * @uses ArrayOfUploadDocument::setUploadDocument()
     * @param UploadDocument[] $uploadDocument
     */
    public function __construct(array $uploadDocument = array())
    {
        $this
            ->setUploadDocument($uploadDocument);
    }
    /**
     * Get UploadDocument value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return UploadDocument[]|null
     */
    public function getUploadDocument()
    {
        return isset($this->UploadDocument) ? $this->UploadDocument : null;
    }
    /**
     * Set UploadDocument value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param UploadDocument[] $uploadDocument
     * @return ArrayOfUploadDocument
     */
    public function setUploadDocument(array $uploadDocument = array())
    {
        if (is_null($uploadDocument) || (is_array($uploadDocument) && empty($uploadDocument))) {
            unset($this->UploadDocument);
        } else {
            $this->UploadDocument = $uploadDocument;
        }
        return $this;
    }
    /**
     * Add item to UploadDocument value
     * @throws \InvalidArgumentException
     * @param UploadDocument $item
     * @return ArrayOfUploadDocument
     */
    public function addToUploadDocument(UploadDocument $item)
    {
        $this->UploadDocument[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return UploadDocument|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return UploadDocument|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return UploadDocument|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return UploadDocument|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return UploadDocument|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UploadDocument
     */
    public function getAttributeName()
    {
        return 'UploadDocument';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return ArrayOfUploadDocument
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
