<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ArrayOfstring' => 'ArrayOfstring',
            'ArrayOfbase64Binary' => 'ArrayOfbase64Binary',
            'Agent' => 'Agent',
            'Holder' => 'Holder',
            'PolicyHolder' => 'PolicyHolder',
            'GetProductList' => 'GetProductList',
            'GetProductListResponse' => 'GetProductListResponse',
            'XmlDataResult' => 'XmlDataResult',
            'GetCodeLists' => 'GetCodeLists',
            'GetCodeListsResponse' => 'GetCodeListsResponse',
            'GetCodeListItems' => 'GetCodeListItems',
            'GetCodeListItemsResponse' => 'GetCodeListItemsResponse',
            'GetItemsDefinition' => 'GetItemsDefinition',
            'GetItemsDefinitionResponse' => 'GetItemsDefinitionResponse',
            'GetContractsInfo' => 'GetContractsInfo',
            'GetContractsInfoResponse' => 'GetContractsInfoResponse',
            'ArrayOfContractInfo' => 'ArrayOfContractInfo',
            'ContractInfo' => 'ContractInfo',
            'ArrayOfContractEvent' => 'ArrayOfContractEvent',
            'ContractEvent' => 'ContractEvent',
            'GetContractInfo' => 'GetContractInfo',
            'GetContractInfoResponse' => 'GetContractInfoResponse',
            'Credentials' => 'Credentials',
            'SimulationData' => 'SimulationData',
            'ArrayOfDataElement' => 'ArrayOfDataElement',
            'DataElement' => 'DataElement',
            'SimulationResult' => 'SimulationResult',
            'ResultData' => 'ResultData',
            'SimulationAndProposalData' => 'SimulationAndProposalData',
            'ContractResult' => 'ContractResult',
            'Documents' => 'Documents',
            'SimulationAndOfferData' => 'SimulationAndOfferData',
            'OfferResult' => 'OfferResult',
            'ContractChangedData' => 'ContractChangedData',
            'ContractChangeResult' => 'ContractChangeResult',
            'ContractData' => 'ContractData',
            'ArrayOfUploadDocument' => 'ArrayOfUploadDocument',
            'UploadDocument' => 'UploadDocument',
            'RegistrationResultData' => 'RegistrationResultData',
            'ResultDocuments' => 'ResultDocuments',
            'ContractsFilter' => 'ContractsFilter',
            'ContractsInfoResult' => 'ContractsInfoResult',
            'ContractInfoResult' => 'ContractInfoResult',
            'SignedContractData' => 'SignedContractData',
            'ArrayOfSignedDocument' => 'ArrayOfSignedDocument',
            'SignedDocument' => 'SignedDocument',
            'SignedContractUploadResult' => 'SignedContractUploadResult',
            'Simulate' => 'Simulate',
            'SimulateResponse' => 'SimulateResponse',
            'CreateContract' => 'CreateContract',
            'CreateContractResponse' => 'CreateContractResponse',
            'CreateOffer' => 'CreateOffer',
            'CreateOfferResponse' => 'CreateOfferResponse',
            'ChangeContract' => 'ChangeContract',
            'ChangeContractResponse' => 'ChangeContractResponse',
            'RegisterContract' => 'RegisterContract',
            'RegisterContractResponse' => 'RegisterContractResponse',
            'ConfirmContract' => 'ConfirmContract',
            'ConfirmContractResponse' => 'ConfirmContractResponse',
            'RevokeContract' => 'RevokeContract',
            'RevokeContractResponse' => 'RevokeContractResponse',
            'GetContractDocuments' => 'GetContractDocuments',
            'GetContractDocumentsResponse' => 'GetContractDocumentsResponse',
            'UploadSignedContract' => 'UploadSignedContract',
            'UploadSignedContractResponse' => 'UploadSignedContractResponse',
            'AuthenticationFault' => 'AuthenticationFault',
            'DuplicatedContractFault' => 'DuplicatedContractFault',
            'InvalidSignedContractFault' => 'InvalidSignedContractFault',
            'ExternalBioSignServiceFault' => 'ExternalBioSignServiceFault',
            'InvalidExternallySignedContractFault' => 'InvalidExternallySignedContractFault',
            'ApplicationException' => 'ApplicationException',
            'Exception' => 'Exception',
        );
    }
}
