<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContractEvent StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ContractEvent
 * @subpackage Structs
 */
class ContractEvent extends AbstractStructBase
{
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * The Created
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Created;
    /**
     * Constructor method for ContractEvent
     * @uses ContractEvent::setType()
     * @uses ContractEvent::setCreated()
     * @param string $type
     * @param string $created
     */
    public function __construct($type = null, $created = null)
    {
        $this
            ->setType($type)
            ->setCreated($created);
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses EventTypeExternal::valueIsValid()
     * @uses EventTypeExternal::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return ContractEvent
     */
    public function setType($type = null)
    {
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Created value
     * @return string|null
     */
    public function getCreated()
    {
        return $this->Created;
    }
    /**
     * Set Created value
     * @param string $created
     * @return ContractEvent
     */
    public function setCreated($created = null)
    {
        $this->Created = $created;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return ContractEvent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
