<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Documents StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:Documents
 * @subpackage Structs
 */
class Documents extends AbstractStructBase
{
    /**
     * The Content
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var ArrayOfbase64Binary
     */
    public $Content;
    /**
     * Constructor method for Documents
     * @uses Documents::setContent()
     * @param ArrayOfbase64Binary $content
     */
    public function __construct(ArrayOfbase64Binary $content = null)
    {
        $this
            ->setContent($content);
    }
    /**
     * Get Content value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return ArrayOfbase64Binary|null
     */
    public function getContent()
    {
        return isset($this->Content) ? $this->Content : null;
    }
    /**
     * Set Content value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param ArrayOfbase64Binary $content
     * @return Documents
     */
    public function setContent(ArrayOfbase64Binary $content = null)
    {
        if (is_null($content) || (is_array($content) && empty($content))) {
            unset($this->Content);
        } else {
            $this->Content = $content;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return Documents
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
