<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OfferResult StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:OfferResult
 * @subpackage Structs
 */
class OfferResult extends SimulationResult
{
    /**
     * The Offers
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var Documents
     */
    public $Offers;
    /**
     * Constructor method for OfferResult
     * @uses OfferResult::setOffers()
     * @param Documents $offers
     */
    public function __construct(Documents $offers = null)
    {
        $this
            ->setOffers($offers);
    }
    /**
     * Get Offers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return Documents|null
     */
    public function getOffers()
    {
        return isset($this->Offers) ? $this->Offers : null;
    }
    /**
     * Set Offers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param Documents $offers
     * @return OfferResult
     */
    public function setOffers(Documents $offers = null)
    {
        if (is_null($offers) || (is_array($offers) && empty($offers))) {
            unset($this->Offers);
        } else {
            $this->Offers = $offers;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return OfferResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
