<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResultDocuments StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ResultDocuments
 * @subpackage Structs
 */
class ResultDocuments extends ResultData
{
    /**
     * The Documents
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var ArrayOfbase64Binary
     */
    public $Documents;
    /**
     * The GeneralXml
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $GeneralXml;
    /**
     * Constructor method for ResultDocuments
     * @uses ResultDocuments::setDocuments()
     * @uses ResultDocuments::setGeneralXml()
     * @param ArrayOfbase64Binary $documents
     * @param string $generalXml
     */
    public function __construct(ArrayOfbase64Binary $documents = null, $generalXml = null)
    {
        $this
            ->setDocuments($documents)
            ->setGeneralXml($generalXml);
    }
    /**
     * Get Documents value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return ArrayOfbase64Binary|null
     */
    public function getDocuments()
    {
        return isset($this->Documents) ? $this->Documents : null;
    }
    /**
     * Set Documents value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param ArrayOfbase64Binary $documents
     * @return ResultDocuments
     */
    public function setDocuments(ArrayOfbase64Binary $documents = null)
    {
        if (is_null($documents) || (is_array($documents) && empty($documents))) {
            unset($this->Documents);
        } else {
            $this->Documents = $documents;
        }
        return $this;
    }
    /**
     * Get GeneralXml value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGeneralXml()
    {
        return isset($this->GeneralXml) ? $this->GeneralXml : null;
    }
    /**
     * Set GeneralXml value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $generalXml
     * @return ResultDocuments
     */
    public function setGeneralXml($generalXml = null)
    {
        if (is_null($generalXml) || (is_array($generalXml) && empty($generalXml))) {
            unset($this->GeneralXml);
        } else {
            $this->GeneralXml = $generalXml;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return ResultDocuments
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
