<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SimulationResult StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:SimulationResult
 * @subpackage Structs
 */
class SimulationResult extends ResultData
{
    /**
     * The CalculatedValues
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var ArrayOfDataElement
     */
    public $CalculatedValues;
    /**
     * Constructor method for SimulationResult
     * @uses SimulationResult::setCalculatedValues()
     * @param ArrayOfDataElement $calculatedValues
     */
    public function __construct(ArrayOfDataElement $calculatedValues = null)
    {
        $this
            ->setCalculatedValues($calculatedValues);
    }
    /**
     * Get CalculatedValues value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return ArrayOfDataElement|null
     */
    public function getCalculatedValues()
    {
        return isset($this->CalculatedValues) ? $this->CalculatedValues : null;
    }
    /**
     * Set CalculatedValues value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param ArrayOfDataElement $calculatedValues
     * @return SimulationResult
     */
    public function setCalculatedValues(ArrayOfDataElement $calculatedValues = null)
    {
        if (is_null($calculatedValues) || (is_array($calculatedValues) && empty($calculatedValues))) {
            unset($this->CalculatedValues);
        } else {
            $this->CalculatedValues = $calculatedValues;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return SimulationResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
