<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XmlDataResult StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:XmlDataResult
 * @subpackage Structs
 */
class XmlDataResult extends ResultData
{
    /**
     * The XmlData
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $XmlData;
    /**
     * Constructor method for XmlDataResult
     * @uses XmlDataResult::setXmlData()
     * @param string $xmlData
     */
    public function __construct($xmlData = null)
    {
        $this
            ->setXmlData($xmlData);
    }
    /**
     * Get XmlData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getXmlData()
    {
        return isset($this->XmlData) ? $this->XmlData : null;
    }
    /**
     * Set XmlData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $xmlData
     * @return XmlDataResult
     */
    public function setXmlData($xmlData = null)
    {
        if (is_null($xmlData) || (is_array($xmlData) && empty($xmlData))) {
            unset($this->XmlData);
        } else {
            $this->XmlData = $xmlData;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return XmlDataResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
